"{ Package: 'stx:goodies/petitparser/compiler' }"

"{ NameSpace: Smalltalk }"

Object subclass:#PPCCompilerTokenizingRememberStrategy
	instanceVariableNames:'compiler'
	classVariableNames:''
	poolDictionaries:''
	category:'PetitCompiler-Compiler'
!


!PPCCompilerTokenizingRememberStrategy class methodsFor:'instance creation'!

on: aPPCCompiler
    ^ self new
        compiler: aPPCCompiler;
        yourself
! !

!PPCCompilerTokenizingRememberStrategy methodsFor:'accessing'!

compiler: aPPCCompiler
    compiler := aPPCCompiler 
! !

!PPCCompilerTokenizingRememberStrategy methodsFor:'as yet unclassified'!

smartRemember: parser to: variableName 
    parser isContextFree ifTrue: [ 
        compiler codeAssign: '{ context lwRemember. currentTokenType . currentTokenValue }.' 
"		compiler codeAssign: 'context lwRemember.' "
                    to: variableName.
    ] ifFalse: [ 
        compiler codeAssign: '{ context remember. currentTokenType . currentTokenValue }.'
                    to: variableName.
    ]
!

smartRestore: parser from: mementoName
    parser isContextFree ifTrue: [ 
        compiler add: 'context lwRestore: (', mementoName, ' at: 1).'.
"		compiler add: 'context lwRestore: ', mementoName, '.'."
    ] ifFalse: [ 
        compiler add: 'context restore: (', mementoName, ' at: 1).'.
    ].

    compiler codeAssign: '(', mementoName, ' at: 2).' to: 'currentTokenType'.
    compiler codeAssign: '(', mementoName, ' at: 3).' to: 'currentTokenValue'.	
    
! !

!PPCCompilerTokenizingRememberStrategy class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

